unit Cli1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uCiaPipes, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo: TRichEdit;
    ToSend: TEdit;
    SendBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure SendBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    PipeCli: TPipeClient;
    procedure PipeDataAvailable(Sender: TObject; Data: PChar; Len: integer);
    procedure PipeSessionConnected(Sender: TObject);
    procedure PipeSessionDisconnected(Sender: TObject);
    procedure PipeError(Sender: TObject; Error: integer);
    procedure Log(const ToLog: string);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
   PipeCli := TPipeClient.Create('mestdagh.biz.demo.testPipe');
//   PipeCli.ServerName := 'annemie';
   PipeCli.OnSessionConnected := PipeSessionConnected;
   PipeCli.OnSessionDisconnected := PipeSessionDisconnected;
   PipeCli.OnDataAvailable := PipeDataAvailable;
   PipeCli.OnError := PipeError;
   Log('Connecting');
   PipeCli.Resume;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   PipeCli.Free;
end;

procedure TForm1.PipeSessionConnected(Sender: TObject);
begin
   Log('Connected');
end;

procedure TForm1.PipeSessionDisconnected(Sender: TObject);
begin
   Log('Disconnected');
end;

procedure TForm1.PipeDataAvailable(Sender: TObject; Data: PChar; Len: integer);
begin
   Log('Rcvd: ' + Data);
end;

procedure TForm1.SendBtnClick(Sender: TObject);
begin
   PipeCli.WriteStr(ToSend.Text);
end;

procedure TForm1.Log(const ToLog: string);
begin
   Memo.Lines.Add(ToLog);
   Memo.Perform(EM_SCROLLCARET, 0, 0);
end;

procedure TForm1.PipeError(Sender: TObject; Error: integer);
begin
   Log('Error: ' + IntToStr(Error));
end;

end.
