unit Srv1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uCiaPipes, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo: TRichEdit;
    SendBtn: TButton;
    ToSend: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SendBtnClick(Sender: TObject);
  private
    PipeSrv: TPipeServer;
    procedure PipeDataAvailable(Sender: TObject; Data: PChar; Len: integer);
    procedure PipeSessionConnected(Sender: TObject);
    procedure PipeSessionDisconnected(Sender: TObject);
    procedure PipeError(Sender: TObject; Error: integer);
    procedure Log(const ToLog: string);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
   PipeSrv := TPipeServer.Create('mestdagh.biz.demo.testPipe');
   PipeSrv.OnDataAvailable := PipeDataAvailable;
   PipeSrv.OnSessionConnected := PipeSessionConnected;
   PipeSrv.OnSessionDisconnected := PipeSessionDisconnected;
   PipeSrv.OnError := PipeError;
   PipeSrv.Resume;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   PipeSrv.Free;
end;

procedure TForm1.PipeDataAvailable(Sender: TObject; Data: PChar; Len: integer);
begin
   Log('Rcvd: ' + Data);
   PipeSrv.WriteStr(UpperCase(Data));
end;

procedure TForm1.PipeSessionConnected(Sender: TObject);
begin
   Log('Client connected');
end;

procedure TForm1.PipeSessionDisconnected(Sender: TObject);
begin
   Log('Client disconnected');
end;

procedure TForm1.PipeError(Sender: TObject; Error: integer);
begin
   Log('Error ' + IntToStr(Error));
end;

procedure TForm1.Log(const ToLog: string);
begin
   Memo.Lines.Add(ToLog);
   Memo.Perform(EM_SCROLLCARET, 0, 0);
end;

procedure TForm1.SendBtnClick(Sender: TObject);
begin
   PipeSrv.WriteStr(ToSend.Text);
end;

end.
